Page MenuHomePhabricator

Consider using the Badges application for a few special roles to highlight those users' comments
Open, LowPublic

Description

I think it might be appropriate to use Badges to designate people who have a deciding role like Architecture Committee members (if we're still keeping that), stewards, or WMF legal. People who don't comment a great deal, but when they do their word is often final or at least strongly deciding. (I was going to suggest roots, but that'd make discussions in Operations very cluttered.)

See also T64324: Visually indicate when a Phabricator user is new (Welcome culture) where using Badges automatically for newbies to welcome them was suggested.

Event Timeline

Jdforrester-WMF raised the priority of this task from to Needs Triage.
Jdforrester-WMF updated the task description. (Show Details)
Jdforrester-WMF added a project: Phabricator.
Jdforrester-WMF added a subscriber: Jdforrester-WMF.
Restricted Application added a project: acl*sre-team. · View Herald TranscriptJul 25 2015, 12:40 AM
Restricted Application added subscribers: scfc, Aklapper. · View Herald Transcript
Jdforrester-WMF triaged this task as Normal priority.Jul 25 2015, 12:40 AM
Jdforrester-WMF removed a project: acl*sre-team.
Jdforrester-WMF set Security to None.

I think it might be appropriate to use Badges to designate people who have a deciding role like Architecture Committee members (if we're still keeping that), stewards, or WMF legal. People who don't comment a great deal, but when they do their word is often final or at least strongly deciding.

I'm not sure I like this idea. Do you have any examples of users from these groups using their role to decide a few discussions?

Aklapper lowered the priority of this task from Normal to Low.Jul 25 2015, 12:53 PM
Qgil added a subscriber: Qgil.Jul 27 2015, 2:24 PM

Badges are being implemented upstream and, in fact, you can see epriestley & co wearing already some. https://secure.phabricator.com/badges/

Qgil added a comment.Aug 9 2015, 8:45 AM

Recovering some comments from the other thread (sorry, I had forgot about this one).

This is a prototype application and what comes closer to documentation can be found at https://secure.phabricator.com/T6526
I like the idea in general, and the only thing I would avoid was to create a dozen badges for starters. Instead, we can implement new badges progressively as we find new good ideas for them. A first one could be "Phabricator admin".

I disagree, and think they should be turned off until further discussion, There is no reason to segregate users like this unless we come up with further guidelines on usage cases

Nor do we badge users on our other services such as the Wikis.

If Badges are contentious then we should remove them and discuss further. I have no strong opinions either way.

We now have the following rubbish:

  • Tea Lover (DESCRIPTION: This user loves tea!)
  • Volunteer (DESCRIPTION: People who are proud to call themselves just volunteers for the Wikimedia movement. Well, we are awesome!)
Deskana added a subscriber: Deskana.EditedAug 12 2015, 4:19 AM

I do not agree with the rationale provided in the description for this task. People demonstrate that they are worth listening to with their words, without the need for special badges. I worry we will create an unnecessary hierarchy by elevating some people above others. Let their comments stand on their own merits, and let others assess them based on that.

We now have the following rubbish:

  • Tea Lover (DESCRIPTION: This user loves tea!)
  • Volunteer (DESCRIPTION: People who are proud to call themselves just volunteers for the Wikimedia movement. Well, we are awesome!)

This comment is not helpful. If there is some issue that this causes, please do state that explicitly and it can be discussed.

Qgil added a comment.EditedAug 12 2015, 6:47 AM

Allowing all users to create badges is even a step further.

https://phabricator.wikimedia.org/badges/

Can we please restrict permissions and, actually, remove badges for now, until there is a clearer plan agreed?

I uninstalled the application since it is apparently not enforcing policies.

Krenair closed this task as Declined.Aug 12 2015, 4:28 PM
Krenair claimed this task.

I think it might be appropriate to use Badges to designate people who have a deciding role like Architecture Committee members (if we're still keeping that), stewards, or WMF legal. People who don't comment a great deal, but when they do their word is often final or at least strongly deciding.

I'm not sure I like this idea. Do you have any examples of users from these groups using their role to decide a few discussions?

I'm not sure I like this idea much either, though it's certainly not without precedent elsewhere (e.g., "staff" badges on GitHub user profiles).

In the case that someone is trying to use their authority in a discussion, I think it's simple enough to do that in words. This also eliminates the maintenance overhead of keeping badges in sync with user accounts/roles.

I don't think there's a real need to know who's on the Architecture Committee as it doesn't rule development in that way. Ideas are discussed as ideas, on their merits.

An alternate idea here might be to signify which Gerrit groups a user is a member of. That would have less maintenance overhead (no manual syncing) and might actually be significant to the discussion as Gerrit group membership correlates with the power to merge code into the master/canonical code repository.

Luke081515 reopened this task as Open.Feb 22 2016, 4:25 PM
Luke081515 added a subscriber: Luke081515.

Reopening this since we have now a create policy for badges, forms for badges, and we can remove a badge from a user.

Luke081515 removed Krenair as the assignee of this task.Feb 22 2016, 4:25 PM
Luke081515 moved this task from To Triage to Need discussion on the Phabricator board.
Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptJul 2 2016, 7:33 PM
Aklapper moved this task from Need discussion to Misc on the Phabricator board.Oct 7 2016, 5:03 PM

In addition to this task (T106924: Consider using the Badges application for a few special roles to highlight those users' comments), we have at least these other tasks:

It seems badges are now enabled again in this Phabricator installation.

Do badges require acceptance by the user during the assignment process?

It appears that the Badges application is enabled again now. I have the "Tea Lover" badge again, which I've created and given myself the last time it was enabled (and when it wasn't checking for permissions for such things).

The permissions checks are fixed and badges is (I believe) close to being 'un-prototyped' upstream (meaning: brought out of beta)

@MZMcBride: badges do not require acceptance by the recipient.

Qgil removed a subscriber: Qgil.Mar 14 2017, 2:14 PM

@MZMcBride: badges do not require acceptance by the recipient.

Thanks for the info. Can only the recipient (and Phabricator admins) remove badges from a user? There's abuse potential with this type of thing, surely.

Regarding the feature itself, I'm not sure it's aligned with our values. I personally find it somewhat obnoxious to have little cryptic and colorful icons next to each comment on a Maniphest task. If I scroll over one of the icons, it tells me "Phabricator Admin". How is this relevant to the comment? On-wiki and elsewhere, we've generally eschewed status symbols (user groups, edit counts, user IDs, user registration dates) in comments and in the user interface generally because we typically want the focus to be on the content, not the contributor.

It's a per-badge edit policy which controls who can award or remove each badge. Currently that should be set to phabricator admins for all of the active badges.

demon added a subscriber: demon.Mar 14 2017, 3:38 PM

I don't want badges, so I removed mine.

Peachey88 added a subscriber: Qgil.Mar 14 2017, 8:36 PM

@mmodell Was there any discussion before you decided to re-install the application?

{Badges/User icons/Whatever} have been discussed repeatedly all the way back since the BugZilla days, and a major complaint/sticking point that has continually surfaced during the discussions is the potential to divide the contributing community as ideas and discussion should be lead by the quality of discussion, not because someone, for example, has a "wmf staff" icon.

Was their any thought of this when re-enabling this or any plan of process implemented as suggested to @Qgil previously on this very task (T106924#1530728)

@Peachey88: no, actually I enabled the application to try it out and see if the policy controls were indeed fixed. I don't think that the concern of dividing the community applies here because we don't have a "wmf staff" icon. I would envision having badges that acknowledge unique contributions or specific privileges / roles.

As examples, the two badges below my avatar: SWAT Deployer and Phabricator Admin. These do not make my opinion any more valuable or valid than anyone's.

And honestly, I'm not sure whether the badges really add value or not. I think they _might_ be a good way to give appreciation and recognition to new contributors but it will take a bit of creative thinking to come up with appropriate badges and award them fairly.

So I think we should keep this discussion open. I don't see any harm done by enabling the application in order to further explore ideas. If this is alienating someone or otherwise causing harm then we can disable the app once more. So far I am not convinced of the harm or the benefit, only the potential.

I was using WMF staff as a example that has been discussed many times before, But it's no different than you own examples of Phab Admin or SWAT deployer tbh.

I like badges. I doint see anything wrong in using badges.

zhuyifei1999 added a subscriber: zhuyifei1999.
hashar added a subscriber: hashar.Mar 23 2017, 11:39 AM

We have a few badges now https://phabricator.wikimedia.org/badges/

I can understand fears of potential community divide or further reinforcing the perception of a meritocracy dictatorship. On the other end, for new comers or people not knowing everyone yet, the tokens are a good way to hint about a user area of expertise. That would surely help driving more communication and ironically reduce the perceived community divide :-}

I like badges and I have filled a task to get a badge for continuous integration related contributions T161208. Intended to be shown as a token of appreciation to people that helps on that front.

Qgil added a comment.Mar 23 2017, 3:00 PM

for new comers or people not knowing everyone yet, the tokens are a good way to hint about a user area of expertise. That would surely help driving more communication and ironically reduce the perceived community divide :-}

I agree.

Userboxes are used in many Wikimedia projects, and they accomplish a similar function. Today anyone can see in @hashar's post above that he is one of several SWAT Deployers. Imagine badges for "Catalan speakers", "Lua lovers", "Possible mentors"...

Just like userboxes, categories, tags... there is a risk for uncontrolled growth, lack of maintenance, outdated information, duplication... yet we do keep having userboxes, categories, tags...

As said, I think it is worth experimenting, see where it goes, and check whether these badges become useful.

I like the idea of a possible mentors badge.

Userboxes are used in many Wikimedia projects, and they accomplish a similar function. Today anyone can see in @hashar's post above that he is one of several SWAT Deployers. Imagine badges for "Catalan speakers", "Lua lovers", "Possible mentors"...

Userboxes are pretty different IMO. They're only on your profile page, not every time you make a comment. But more importantly users can create their own userboxes, and choose themselves whether to use them. In this case badges that seem totally reasonable like https://phabricator.wikimedia.org/badges/view/4/ get disabled, or others request badges to be added to others (e.g. T161208, no doubt in good faith), but I can't even remove a badge I don't want.

I think having badges only available to a very restricted group of people is probably the worst option - either make it available and ediable by everyone (more like userboxes) or just turn them off.

Badges are dumb, just like userboxes are. If anyone adds them to my account expect me to remove them.

Userboxes are pretty different IMO. They're only on your profile page, not every time you make a comment.

{{agree}} - Compared to userboxes, badges are more like a non-default gadget MarkAdmins, which adds the rights of a user right into links to userpages, most of the time signatures. I don't use this gadget; it creates a bias towards users with higher rights automagically in the subconscious.

I think having badges only available to a very restricted group of people is probably the worst option - either make it available and ediable by everyone (more like userboxes) or just turn them off.

Just turn them off - making them available to everyone is no better. Userboxes are available to everyone, and now we can see countless userboxes inflation. Unlike userboxes which are fully customizable in where they are placed, badges are not, and having too many badges in a discussion creates unnecessary clutter of colorfulness and distraction.

It's fine if badges are limited to personal pages, but inside discussion, no thanks.

Userboxes are used in many Wikimedia projects, [...]

For what it's worth, at least on the English Wikipedia, userboxes were very controversial. If you search around for "userbox wars" (I'm completely serious), you can read about some of the issues: https://en.wikipedia.org/wiki/Wikipedia:T1_and_T2_debates, https://en.wikipedia.org/wiki/Wikipedia:Jimbo_on_Userboxes, https://en.wikipedia.org/wiki/Wikipedia:German_userbox_solution, etc. I doubt this is something we want to replicate in Wikimedia Phabricator.

Today anyone can see in @hashar's post above that he is one of several SWAT Deployers.

Hashar is posting about badges, though. How is it relevant to anyone reading his post about badges that he's a "SWAT Deployer". This fact is irrelevant to many of Hashar's Phabricator Maniphest posts. And that particular label/badge is especially meaningless to almost every reader. SWAT is internal jargon, as far as I know.

Just like userboxes, categories, tags... there is a risk for uncontrolled growth, lack of maintenance, outdated information, duplication... yet we do keep having userboxes, categories, tags...

Right, it assumes a sizable amount of maintenance cost for arguably very little benefit.

Let me put it this way: I think having a list of possible mentors would be great. I think having a list of contactable people regarding deployments would be great. I don't think Phabricator badges are a good way of creating these lists. Creating wiki pages seems like a pretty good approach to me.

While I'm not often in support of user preferences, perhaps we should explore the ability to hide tokens, avatars, and badges on a per-user basis. We could do this with a formal user preference or with something a little messier like embedding a CSS page from the wiki (e.g., https://meta.wikimedia.org/wiki/User:MZMcBride/phabricator.css). I think I wanted something similar for Bugzilla at some point? It turns out that in a world where HTML styling is controlled by CSS, it can be very useful to be able to inject some CSS of your own sometimes. :-)

@MZMcBride: I suspect you're already aware of https://userstyles.org/

I wouldn't be against making a user preference to disable avatars/badges .. Tokens might be more difficult, I'm not sure about those.

@MZMcBride: I suspect you're already aware of https://userstyles.org/
I wouldn't be against making a user preference to disable avatars/badges .. Tokens might be more difficult, I'm not sure about those.

I like being able to customise my avatar. I also like the badges.

So looks like we have badges now and they are used for a few special roles which I guess fulfill this task.

To summarize the caveats exposed above:

Opt out from badges

Some would rather not have badges imposed to them. Seems like the badge can be rescinded by the recipient on a self serve basis via:

Distracting

List of badges show under the users avatar can be distracted. There is apparently no user/style preference to hide them.

  • As a workaround, one can use a custom stylesheet that hides div.phui-timeline-badges
  • Should we add to Phabricator an user preference to hide them easily? Might not be worth it, I don't know really

Proliferation of useless badges

We might end up with a bazaar of random badges that would clutter everything (eg: Tea Lover Badge that got archived). It seems the creation of a badge is reserved to administrators, thus creation would be requested via a Phabricator task which would let us reject such requests

In conclusion, looks like this task is fulfilled (we have a few special case badges). Potentially we might want to summarize the above discussion at some place for the administrators to refer to later on.

Userboxes are used in many Wikimedia projects, and they accomplish a similar function. Today anyone can see in @hashar's post above that he is one of several SWAT Deployers. Imagine badges for "Catalan speakers", "Lua lovers", "Possible mentors"...

Userboxes are pretty different IMO. They're only on your profile page, not every time you make a comment. But more importantly users can create their own userboxes, and choose themselves whether to use them.

Phabricator lets you chose a role, its controlled by the user, shown on their profile (or the popup near their name), and is fun (...or serious). Sometimes it also tells you important things about the user, but not on every comment, only if you look. I don't think we need the badges application along with this.

Honestly I think it would be cool if badges only showed on a user's profile and not on their comments. Maybe we should patch phabricator to display them next to the "role" thing on user profiles and hide them on avatars.

Honestly I think it would be cool if badges only showed on a user's profile and not on their comments.

Agreed.

Prtksxna added a comment.EditedMar 30 2017, 5:19 PM

Honestly I think it would be cool if badges only showed on a user's profile and not on their comments. Maybe we should patch phabricator to display them next to the "role" thing on user profiles and hide them on avatars.

👍

They are already visible in the "Badges" section. It'll be nice to have them show on the popup too. Also, if we are keeping them, with this change they wont clutter the comments UI either, and so, should be opened up to everyone (to create, award, and refuse).

Aklapper moved this task from Misc to Policies on the Phabricator board.Aug 29 2018, 6:04 PM